module Main
#
# top level constants
#
  Main::VERSION = '2.7.0' unless
    defined? Main::VERSION
  def self.version() Main::VERSION end

  Main::LIBDIR = File.join(File.dirname(File.expand_path(__FILE__)), self.name.downcase, '') unless
    defined? Main::LIBDIR
  def self.libdir() Main::LIBDIR end

  Main::EXIT_SUCCESS = 0 unless defined? Main::EXIT_SUCCESS
  Main::EXIT_FAILURE = 1 unless defined? Main::EXIT_FAILURE
  Main::EXIT_WARN = 42 unless defined? Main::EXIT_WARN
#
# built-in
#
  require 'logger'
  require 'enumerator'
  require 'set'
#
# use gems to pick up dependancies
#
  require 'rubygems'
  gem 'attributes', '~> 5.0.0'
  require 'attributes'
  gem 'arrayfields', '~> 4.5.0'
  require 'arrayfields'
#
# main's own libs
#
  require libdir + 'stdext'
  require libdir + 'softspoken'
  require libdir + 'util'
  require libdir + 'logger'
  require libdir + 'usage'
  require libdir + 'cast'
  require libdir + 'parameter'
  require libdir + 'getoptlong'
  require libdir + 'mode'
  require libdir + 'base'
  require libdir + 'factories'
end
